@echo off

setlocal

set buildname=trunk
set buildtag=win32
set package=call "..\package.bat"
set buildtarget=psi\win32\psi
set keepxbuilds=2
set keepxpdbs=4
set keepxfailedbuilds=2
set keepxnochanges=2

set update=0

for %%a in (%0) do set root=%%~dpa

set updatelog=%root%svnup.log
set loglog=%root%svnlog.log

set previrev=0
for /f "usebackq tokens=1,2 delims= " %%a in (`svn info psi/iris`) do @if "%%a" == "Revision:" set previrev=%%b
set prevrev=0
for /f "usebackq tokens=1,2 delims= " %%a in (`svn info psi`) do @if "%%a" == "Revision:" set prevrev=%%b

set buildrev=r%prevrev%-i%previrev%

if "%1" == "skipcheck" goto :parselog
if "%1" == "justbuild" goto :build

if exist "%updatelog%" del "%updatelog%"
if exist "%loglog%" del "%loglog%"

svn up psi > "%updatelog%" 2>&1

set newirev=0
for /f "usebackq tokens=1,2 delims= " %%a in (`svn info psi/iris`) do @if "%%a" == "Revision:" set newirev=%%b
set newrev=0
for /f "usebackq tokens=1,2 delims= " %%a in (`svn info psi`) do @if "%%a" == "Revision:" set newrev=%%b

set buildrev=r%newrev%-i%newirev%

if %previrev% == %newirev% goto checkpsirev

set /a previrev=%previrev%+1
svn log psi/iris -r %previrev%:%newirev% >> "%loglog%" 2>&1

:checkpsirev

if %prevrev% == %newrev% goto preparselog

set /a prevrev=%prevrev%+1
svn log psi -r %prevrev%:%newrev% >> "%loglog%" 2>&1

:preparselog

echo.Now run '%0 skipcheck' to force a rebuild
goto :eof

:parselog

set conflicts=0
for /f "usebackq delims= " %%a in ("%updatelog%") do if "%%a" == "C" set conflicts=1
if "%conflicts%" == "1" goto failed

for /f "usebackq tokens=1,2,3 delims= " %%a in ("%updatelog%") do if "%%a %%b" == "At revision" set result=nochanges
for /f "usebackq tokens=1,2,3,4 delims= " %%a in ("%updatelog%") do if "%%a %%b %%c" == "Updated to revision" set result=updated
if "%result%" == "nochanges" goto nochanges
if "%result%" == "updated" goto build

goto failed

:nochanges

if not exist %buildtarget%\psi.exe goto build

if not exist %buildtarget%\ md %buildtarget%\
copy "%updatelog%" %buildtarget%\ > nul

%package% %buildname% %buildrev% %buildtag%-nochanges %buildtarget% svnup.log %keepxnochanges%

endlocal

goto :eof

:build

call "..\rebuild.bat" > build.log 2>&1

if errorlevel 1 goto :failed

if not exist %buildtarget%\ md %buildtarget%\
copy *.log %buildtarget%\ > nul
svn diff psi\iris > %buildtarget%\svn-diff.patch
svn diff psi >> %buildtarget%\svn-diff.patch

%package% %buildname% %buildrev% %buildtag%-pdb %buildtarget% Psi.pdb %keepxpdbs% noupload
del %buildtarget%\Psi.pdb
%package% %buildname% %buildrev% %buildtag% %buildtarget% * %keepxbuilds%

endlocal

goto :eof

:failed

if not exist %buildtarget%\ md %buildtarget%\
copy *.log %buildtarget%\ > nul
svn diff psi\iris > %buildtarget%\svn-diff.patch
svn diff psi >> %buildtarget%\svn-diff.patch

%package% %buildname% %buildrev% %buildtag%-buildfailed %buildtarget% *.log %keepxfailedbuilds%

endlocal

goto :eof
