@echo off

setlocal

set buildname=gislan
set buildtag=win32
set package=call "..\package.bat"
set buildtarget=psi\win32\psi
set keepxbuilds=2
set keepxpdbs=4
set keepxfailedbuilds=2
set keepxnochanges=2

set update=0

for %%a in (%0) do set root=%%~dpa

set updatelog=%root%gitpull.log
set loglog=%root%gitlog.log

set prevrev=0
for /f "usebackq tokens=1" %%a in (`git --no-pager --git-dir=psi\.git log --pretty^=format:%%h HEAD~1..HEAD`) do @set prevrev=%%a
set previrev=0
for /f "usebackq tokens=1" %%a in (`git --no-pager --git-dir=psi\iris\.git log --pretty^=format:%%h HEAD~1..HEAD`) do @set previrev=%%a

set buildrev=%prevrev%-%previrev%

if "%1" == "skipcheck" goto :parselog
if "%1" == "justbuild" goto :build

if exist "%updatelog%" del "%updatelog%"
if exist "%loglog%" del "%loglog%"

pushd psi
call git stash save "Local Changes" >> "%updatelog%" 2>&1
call git pull >> "%updatelog%" 2>&1
call git submodule update >> "%updatelog%" 2>&1
call git stash pop >> "%updatelog%" 2>&1
popd

set newrev=0
for /f "usebackq tokens=1" %%a in (`git --no-pager --git-dir=psi\.git log --pretty^=format:%%h HEAD~1..HEAD`) do @set newrev=%%a
set newirev=0
for /f "usebackq tokens=1" %%a in (`git --no-pager --git-dir=psi\iris\.git log --pretty^=format:%%h HEAD~1..HEAD`) do @set newirev=%%a

set buildrev=%newrev%-%newirev%

if %prevrev% == %newrev% goto checkirisrev

call git --no-pager --git-dir=psi\.git log %prevrev%..%newrev% >> "%loglog%" 2>&1

:checkirisrev

if %previrev% == %newirev% goto parselog

call git --no-pager --git-dir=psi\iris\.git log %previrev%..%newirev% >> "%loglog%" 2>&1

:parselog

set errors=0
for /f "usebackq delims= " %%a in ("%updatelog%") do if "%%a" == "error:" set errors=1
if "%errors%" == "1" goto failed

for /f "usebackq tokens=1,2 delims= " %%a in ("%updatelog%") do if "%%a %%b" == "Already up-to-date." set result=nochanges
for /f "usebackq tokens=1,2 delims= " %%a in ("%updatelog%") do if "%%a %%b" == "Fast forward" set result=updated

if "%result%" == "nochanges" goto nochanges
if "%result%" == "updated" goto build

goto failed

:nochanges

if not exist %buildtarget%\psi.exe goto build

if not exist %buildtarget%\ md %buildtarget%\
copy "%updatelog%" %buildtarget%\ > nul

%package% %buildname% %buildrev% %buildtag%-nochanges %buildtarget% gitpull.log %keepxnochanges%

endlocal

goto :eof

:build

call "..\rebuild.bat" > build.log 2>&1

if errorlevel 1 goto :failed

if not exist %buildtarget%\ md %buildtarget%\
copy *.log %buildtarget%\ > nul
pushd psi
call git --no-pager diff >> ..\%buildtarget%\git-diff.patch
popd

%package% %buildname% %buildrev% %buildtag%-pdb %buildtarget% Psi.pdb %keepxpdbs% noupload
del %buildtarget%\Psi.pdb
%package% %buildname% %buildrev% %buildtag% %buildtarget% * %keepxbuilds%

endlocal

goto :eof

:failed

if not exist %buildtarget%\ md %buildtarget%\
copy *.log %buildtarget%\ > nul
pushd psi
call git --no-pager diff >> ..\%buildtarget%\git-diff.patch
popd

%package% %buildname% %buildrev% %buildtag%-buildfailed %buildtarget% *.log %keepxfailedbuilds%

endlocal

goto :eof
